﻿/* Processing key press under different situations. 
   Created by Zoominla, 03-17-2009         
*/
if(typeof(KEY_PROCESS_INCLUDE) != "boolean") {
	KEY_PROCESS_INCLUDE = true;


//------------------------ Key code definition (keyboard)----------------------
const KEY_CODE_ESC = 27;
const KEY_CODE_SPACE = 32;
const KEY_CODE_ENTER = 13;
const KEY_CODE_SHIFT = 16;
const KEY_CODE_CTRL = 17;
const KEY_CODE_LEFT = 37;
const KEY_CODE_RIGHT = 39;
const KEY_CODE_UP = 38;
const KEY_CODE_DOWN = 40;
const KEY_CODE_PAGEUP = 33;
const KEY_CODE_PAGEDOWN = 34;
const KEY_CODE_BACKSPACE = 8;
const KEY_CODE_PLUS = 107;
const KEY_CODE_MINUS = 109;

const KEY_CODE_C = 67;
const KEY_CODE_D = 68;
const KEY_CODE_E = 69;
const KEY_CODE_F = 70;
const KEY_CODE_G = 71;
const KEY_CODE_H = 72;
const KEY_CODE_I = 73;
const KEY_CODE_J = 74;
const KEY_CODE_M = 77;
const KEY_CODE_O = 79;
const KEY_CODE_P = 80;
const KEY_CODE_R = 82;
const KEY_CODE_T = 84;
const KEY_CODE_X = 88;
const KEY_CODE_Z = 90;

//---------------------- Remote control code definition (remote)-------------
const REMOTE_CODE_SLEEP = 255;
const REMOTE_CODE_ESC = 27;
const REMOTE_CODE_ENTER = 13;

const REMOTE_CODE_LEFT = 37;
const REMOTE_CODE_RIGHT = 39;
const REMOTE_CODE_UP = 38;
const REMOTE_CODE_DOWN = 40;
const REMOTE_CODE_PAGEUP = 33;
const REMOTE_CODE_PAGEDOWN = 34;

const REMOTE_CODE_RETURN = 76;
const REMOTE_CODE_PLUS = 106;
const REMOTE_CODE_MINUS = 111;
const REMOTE_CODE_MENU = 77;
const REMOTE_CODE_PREV = 70;
const REMOTE_CODE_NEXT = 71;

const REMOTE_CODE_MUTE = 67;
const REMOTE_CODE_AUDIO_CH = 9;
const REMOTE_CODE_TV = 83;
const REMOTE_CODE_BROADCAST = 89;
const REMOTE_CODE_INFO = 79;
const REMOTE_CODE_FAVORITE = 87;
const REMOTE_CODE_VOD = 144;
const REMOTE_CODE_PROGRAM_LIST = 46;

const REMOTE_CODE_STOP = 81;
const REMOTE_CODE_PLAY = 80;

const REMOTE_CODE_0 = 45;
const REMOTE_CODE_1 = 97;
const REMOTE_CODE_2 = 98;
const REMOTE_CODE_3 = 99;
const REMOTE_CODE_4 = 100;
const REMOTE_CODE_5 = 101;
const REMOTE_CODE_6 = 102;
const REMOTE_CODE_7 = 103;
const REMOTE_CODE_8 = 104;
const REMOTE_CODE_9 = 105;

//------------------------ Situation definition -----------------------------
const CONTROL_BY_KEYBOARD = 0;
const CONTROL_BY_REMOTE = 1;

var ctrlType = CONTROL_BY_KEYBOARD;

function onAppKeyEvent(keycode)
{
	//var KeyID = -1;
	dumpMsg(keycode);
	
	if(ctrlType == CONTROL_BY_KEYBOARD) {
		controlByKey(keycode);
	} else if(ctrlType == CONTROL_BY_REMOTE) {
		controlByRemote(keycode);
	}
}

function controlByKey(keycode)
{
	switch(keycode) {
		case KEY_CODE_ESC :
			if(fs) toggleFullScreen();
			break;
		case KEY_CODE_SPACE :
			pause_cmd();
			break;
		case KEY_CODE_ENTER :
			break;
		case KEY_CODE_SHIFT :
			break;
		case KEY_CODE_CTRL :
			break;
		case KEY_CODE_LEFT :
			mp.rewind(10);
			break;
		case KEY_CODE_RIGHT :
			mp.forward(10);
			break;
		case KEY_CODE_UP :
			break;
		case KEY_CODE_DOWN :
			break;
		case KEY_CODE_PAGEUP :
			prev_cmd();
			break;
		case KEY_CODE_PAGEDOWN :
			next_cmd();
			break;
		case KEY_CODE_BACKSPACE:
			break;
		case KEY_CODE_C:
			//$('mediaList');
			break;
		case KEY_CODE_D:
			if(curViewMode != VIEW_FULL) setViewMode(VIEW_FULL);
			break;
		case KEY_CODE_H:
			setTVMode(1);
			break;
		case KEY_CODE_F:
			toggleFullScreen();
			break;
		case KEY_CODE_J:
			mp.switchSubtitle();
			break;
		case KEY_CODE_O :
			mp.switchOsd();
			break;
		case KEY_CODE_P :
			pause_cmd();
			break;
		case KEY_CODE_R :
			mp.subPosUp();
			break;
		case KEY_CODE_T :
			mp.subPosDown();
			break;
		case KEY_CODE_X :
			mp.delaySub();
			break;
		case KEY_CODE_Z :
			mp.advanceSub();
			break;
		case KEY_CODE_PLUS :
			mp.increaseVolume();
			break;
		case KEY_CODE_MINUS :
			mp.decreaseVolume();
			break;
		
	}
}

function controlByRemote(keycode)
{
	switch(keycode) {
		case REMOTE_CODE_ESC :
			//if(fs) toggleFullScreen();
			break;
		case REMOTE_CODE_PLAY :
			play_cmd();
			break;
		case REMOTE_CODE_ENTER :
			break;
		
		case REMOTE_CODE_LEFT :
			mp.rewind(10);
			break;
		case REMOTE_CODE_RIGHT :
			mp.forward(10);
			break;
		case REMOTE_CODE_UP :
			break;
		case REMOTE_CODE_DOWN :
			break;
		case REMOTE_CODE_PAGEUP :
			prev_cmd();
			break;
		case REMOTE_CODE_PAGEDOWN :
			next_cmd();
			break;
		case REMOTE_CODE_RETURN:
			break;
		case REMOTE_CODE_0:
			toggleFullScreen();
			break;
		case REMOTE_CODE_1:
			//mp.switchSubtitle();
			break;
		case REMOTE_CODE_2 :
			//mp.switchOsd();
			break;
		case REMOTE_CODE_3 :
			//pause_cmd();
			break;
		case REMOTE_CODE_4 :
			//mp.subPosUp();
			break;
		case REMOTE_CODE_5 :
			//mp.subPosDown();
			break;
		case REMOTE_CODE_6 :
			//mp.delaySub();
			break;
		case REMOTE_CODE_7 :
			//mp.advanceSub();
			break;
		case REMOTE_CODE_PLUS :
			mp.increaseVolume();
			break;
		case REMOTE_CODE_MINUS :
			mp.decreaseVolume();
			break;
	}
}

}